package com.usky.dxtop.controller.web;


import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.usky.dxtop.common.core.domain.AjaxResult;
import com.usky.dxtop.common.exception.CustomException;
import com.usky.dxtop.model.Charge;
import com.usky.dxtop.model.Staff;
import com.usky.dxtop.service.ChargeService;
import com.usky.dxtop.service.StaffService;
import com.usky.dxtop.service.vo.ChargeRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.Optional;

/**
 * 充值模块
 * @author yq
 * @since 2021-09-09
 */
@RestController
@RequestMapping("/dxtop/charge")
public class ChargeController {


    @Autowired
    private ChargeService chargeService;

    @Autowired
    private StaffService staffService;

    /**
     * 分页
     * @param chargeRequest
     * @return
     */
    @PostMapping("/page")
    public AjaxResult page(@Validated @RequestBody ChargeRequest chargeRequest){
        return AjaxResult.success(chargeService.page(chargeRequest));
    }


    @PostMapping("/cordPage")
    public AjaxResult cordPage(@Validated @RequestBody ChargeRequest chargeRequest){
        return AjaxResult.success(chargeService.cordPage(chargeRequest));
    }

    /**
     * 充值详情
     * @param seq
     * @return
     */
    @GetMapping(value = "/{seq}")
    public AjaxResult one(@PathVariable Long seq){
        return AjaxResult.success(chargeService.one(seq));
    }

    /**
     * 批量修改消息状态
     * @return
     */
    @PutMapping
    public AjaxResult updateList(@RequestParam String userId){
        Staff staff = staffService.one(userId, null, null);
        Optional.ofNullable(staff).orElseThrow(() -> new CustomException("用户信息不存在"));
        LambdaUpdateWrapper<Charge> updateWrapper = Wrappers.lambdaUpdate();
        updateWrapper.set(Charge::getMessageFlag,true)
                .eq(Charge::getCard,staff.getCardId());
        return AjaxResult.success(chargeService.update(updateWrapper));
    }
}

